<?php
$lib_base = "../gwvplib/";

// initial http file
$WEB_ROOT_FS = realpath(dirname(__FILE__));
$BASE_URL = dirname($_SERVER["PHP_SELF"]);

global $WEB_ROOT_FS, $BASE_URL, $repo_base, $data_directory, $db_type, $db_name, $db_username, $db_password;

// add gwvplib as if it were a path in ../gwvplib
if(file_exists($lib_base)) {
	$path = realpath($lib_base);
	set_include_path(get_include_path().PATH_SEPARATOR.$path);
}

require_once("gwvplib.php");
global $db_type, $db_url;

$db_type = "sqlite";
$db_name = "/tmp/unittestdbperms.db";

unlink($db_name);
gwvp_dbCreateSQLiteStructure("$db_name");
gwvp_ConnectDB();
gwvp_setConfigVal("repodir", "/tmp");

//gwvp_createUser($email, $fullname, $password, $username, $desc, $status);
gwvp_createUser("a1@b.com", "full name1", "asdf", "user1", "asdf", 0);
gwvp_createUser("a2@b.com", "full name2", "asdf", "user2", "asdf", 0);
gwvp_createUser("a3@b.com", "full name3", "asdf", "user3", "asdf", 0);
gwvp_createUser("a4@b.com", "full name4", "asdf", "user4", "asdf", 0);
gwvp_createUser("a5@b.com", "full name5", "asdf", "user5", "asdf", 0);
gwvp_createUser("a6@b.com", "full name6", "asdf", "user6", "asdf", 0);

// gwvp_createGroup($group_name, $group_desc, $is_admin, $owner_id), gwvp_getUserId($useremail=null, $username = null)
gwvp_createGroup("group1", "group1", true, gwvp_getUserId(null, "user1"));
gwvp_createGroup("group2", "group2", true, gwvp_getUserId(null, "user2"));
gwvp_createGroup("group3", "group3", false, gwvp_getUserId(null, "user3"));
gwvp_createGroup("group4", "group4", false, gwvp_getUserId(null, "user4"));
gwvp_createGroup("group5", "group5", false, gwvp_getUserId(null, "user5"));
gwvp_createGroup("group6", "group6", false, gwvp_getUserId(null, "user6"));

/*
 * // 0 - anyone can clone/read, only owner can write
// 1 - noone can clone/read, repo is visible (i.e. name), only owner can read/write repo
// 2 - only owner can see anything
function gwvp_createGitRepo($name, $ownerid, $desc, $bundle=null, $defaultperms=0)

 */
gwvp_createGitRepo("utrepo1", gwvp_getUserId(null, "user1"), "repo1", null, 2);
gwvp_createGitRepo("utrepo2", gwvp_getUserId(null, "user2"), "repo1", null, 2);
gwvp_createGitRepo("utrepo3", gwvp_getUserId(null, "user3"), "repo1", null, 2);
gwvp_createGitRepo("utrepo4", gwvp_getUserId(null, "user4"), "repo1", null, 2);
gwvp_createGitRepo("utrepo5", gwvp_getUserId(null, "user5"), "repo1", null, 2);
gwvp_createGitRepo("utrepo6", gwvp_getUserId(null, "user6"), "repo1", null, 2);

// now the fun part gwvp_addRepoPermission($repoid, $permtype, $permref)
gwvp_addRepoPermission(gwvp_GetRepoId("utrepo1"), "write", "user:".gwvp_getUserId(null, "user3"));
gwvp_addRepoPermission(gwvp_GetRepoId("utrepo2"), "read", "user:".gwvp_getUserId(null, "user3"));
gwvp_addRepoPermission(gwvp_GetRepoId("utrepo4"), "visible", "user:".gwvp_getUserId(null, "user3"));

// lets check user 1 gwvp_resolvRepoPerms($userid, $repoid)
$pers = gwvp_resolvRepoPerms(gwvp_getUserId(null, "user3"), gwvp_GetRepoId("utrepo1"));
echo "User3 pers to repo1 = $pers - should be 3\n";
$pers = gwvp_resolvRepoPerms(gwvp_getUserId(null, "user3"), gwvp_GetRepoId("utrepo2"));
echo "User3 pers to repo2 = $pers - should be 2\n";
$pers = gwvp_resolvRepoPerms(gwvp_getUserId(null, "user3"), gwvp_GetRepoId("utrepo3"));
echo "User3 pers to repo3 = $pers - should be 3 (owner)\n";
$pers = gwvp_resolvRepoPerms(gwvp_getUserId(null, "user3"), gwvp_GetRepoId("utrepo4"));
echo "User3 pers to repo4 = $pers - should be 1\n";
$pers = gwvp_resolvRepoPerms(gwvp_getUserId(null, "user3"), gwvp_GetRepoId("utrepo5"));
echo "User3 pers to repo5 = $pers - should be 0\n";

$pers = gwvp_resolvRepoPerms(gwvp_getUserId(null, "user2"), gwvp_GetRepoId("utrepo5"));
echo "User2 pers to repo5 = $pers - should be 3 (admin)\n";



?>